//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

//
//
//
//
//

extern int LrvPeriod   = 35;
extern int LrvPrice    =  0;

double lrv[];
double lrvDa[];
double lrvDb[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,lrv);
   SetIndexBuffer(1,lrvDa);
   SetIndexBuffer(2,lrvDb);
   SetIndexBuffer(3,slope);
   return(0);
}

//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (slope[limit]==-1) CleanPoint(limit,lrvDa,lrvDb);
      for(int i = limit; i >= 0; i--)
      {
         lrv[i]   = 3.0*iMA(NULL,0,LrvPeriod,0,MODE_LWMA,LrvPrice,i)-2.0*iMA(NULL,0,LrvPeriod,0,MODE_SMA,LrvPrice,i);
         lrvDa[i] = EMPTY_VALUE;
         lrvDb[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
            if (lrv[i]>lrv[i+1]) slope[i] =  1;
            if (lrv[i]<lrv[i+1]) slope[i] = -1;
            if (slope[i] == -1) PlotPoint(i,lrvDa,lrvDb,lrv);
      }   
      return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}